// Tortue.cpp: implementation of the Tortue class.
//
//////////////////////////////////////////////////////////////////////
#include <iostream>
#include <math.h>

#include "Tortue.h"
#include "Ecran.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Tortue::Tortue(Ecran * ecran, double x, double y) : m_X(x), m_Y(y), m_Angle(0), m_Ecran(ecran)
{

}

Tortue::~Tortue()
{

}

TypeParametre Tortue::getPositionX() {
	return m_X;
}

TypeParametre Tortue::getPositionY() {
	return m_Y;
}

void Tortue::avance(TypeParametre distance) {
	std::cout << "Avance de " << distance;
	double x = m_X;
	double y= m_Y;
	m_X = m_X + distance * cos(m_Angle);
	m_Y = m_Y + distance * sin(m_Angle);

	m_Ecran->dessineTrait(x, y, m_X, m_Y);
}

void Tortue::tourne(TypeParametre angle) {
	std::cout << "Tourne de " << angle;
	m_Angle += angle;
}


