#include "StdAfx.h"
#include "ecran.h"
#include "Tortue.h"
#include <vector>
#include <list>
#include <map>
using namespace std;

typedef void (Tortue:: *FnMembreTortue) ( TypeParametre);

typedef pair< FnMembreTortue, TypeParametre> Commande;
typedef vector<  Commande >   Commandes;

const TypeParametre rayon = 100.0;
const int nbPas= 50;
const double PI = 3.1415;
const int nbArcs = 3;

void empiler_un_arc( Commandes &commandes)
{
	for ( int i = 0; i< nbPas; i++){
		// avancer
		Commande c( Tortue::avance, 2.0*PI*rayon/(nbArcs*nbPas) );
		commandes.push_back( c );
		// tourner lgrement
		commandes.push_back( Commande(&Tortue::tourne, 2.0*PI/(nbArcs*nbPas )) );
	}
}

void dessine(HWND hWnd)
{
	Ecran e(hWnd);

	Commandes		commandes;
	for ( int i = 0; i < 6 ; i++){
		empiler_un_arc( commandes);
		// tourner de 120
		commandes.push_back( Commande( &Tortue::tourne, 2.0*PI/3.0) );
	}

	Tortue tortue (&e, e.getXCentre() , e.getYCentre() );
	for ( int i = 0; i < (int)commandes.size() ; i++){
		Commande & c = commandes[i];
		FnMembreTortue f = c.first;
		(tortue.*f)( c.second );
	}
	
}
