// Purpose.  dynamic_cast<T> lab answer

#include <iostream>
#include <vector>
using namespace std;

class Component {
   int value;
public:
   Component( int val )    { value = val; }
   virtual void traverse() { cout << value << " "; }
};

class Primitive : public Component { public:
   Primitive( int val ) : Component( val ) { }
};

class Composite : public Component {
   vector<Component*> children;
public:
   Composite( int val ) : Component( val ) { }
   void add( Component* ele ) { children.push_back( ele ); }
   /*virtual*/ void traverse() {
      Component::traverse();
      for (int i=0; i < children.size(); i++)
         children[i]->traverse();
}  };

void main( void ) {
   Component*  nodes[3], *leaf;
   // The type of Composite* is "lost" when the object is assigned to a
   // Component*
   nodes[0] = new Composite(1);
   nodes[1] = new Composite(2);
   nodes[2] = new Composite(3);

   Composite* ptr;
   if (ptr = dynamic_cast<Composite*>( nodes[0] )) {
      ptr->add( nodes[1] ); 
      ptr->add( nodes[2] );
      ptr->add( new Primitive(4) );
   }
   if (ptr = dynamic_cast<Composite*>( nodes[1] )) {
      ptr->add( new Primitive(5) );
      ptr->add( new Primitive(6) );
   }
   if (ptr = dynamic_cast<Composite*>( nodes[2] )) {
      leaf = new Primitive(7);
      ptr->add( leaf );
   }

   if (ptr = dynamic_cast<Composite*>( leaf )) {
      leaf->traverse();  cout << "IS a Composite*\n";
   } else { leaf->traverse();  cout << "is NOT a Composite*\n"; }
        
   for (int i=0; i < 3; i++) {
      nodes[i]->traverse();
      cout << endl;
}  }

// 7 is NOT a Composite*
// 1 2 5 6 3 7 4 
// 2 5 6 
// 3 7 
