#define PB
/*
===========================
  Int2Type (Alexandrescu)
===========================

problme:
----------
certains objets de type T possdent une mthode Clone (les polymorphiques) et d'autres pas
le code suivant ne compile pas, mme s'il est appliqu  des objets non polymorphiques !
main.cpp: error C2227: la partie gauche de '->Clone' doit pointer vers un class/struct/union

Exercice dj corrig, car assez difficile  imaginer
*/
#include <iostream>
#include <string>
using namespace std;

#ifdef PB
template <typename T, bool isPolymorphic>
class Conteneur
{
public:
	void DoSomething(T* pObj)
	{
		if (isPolymorphic)
		{
			T* pNewObj = pObj->Clone();
			cout << " algorithme polymorphique ..." << endl;
		}
		else
		{
			T* pNewObj = new T(*pObj);
			cout << " algorithme non polymorphique ..." << endl;
		}
	}
};

int main()
{
	Conteneur<int , false> c ;
	c.DoSomething(new int);
	return 0;
}
#else
/*
solution :
----------
utiliser la petite structure template Int2Type suivante :
*/
template <int v>
struct Int2Type
{
enum { value = v };
};

//et le code:
class A{
public:
	A Clone(){
		return A(*this);}
};

template <typename T, bool isPolymorphic>
class Conteneur2
{
private:
void DoSomething(T* pObj, Int2Type<true>)
{
			T* pNewObj = &pObj->Clone();
			cout << " algorithme polymorphique ..." << endl;
}
void DoSomething(T* pObj, Int2Type<false>)
{
			T* pNewObj = new T(*pObj);
			cout << " algorithme non polymorphique ..." << endl;
}
public:
void DoSomething(T* pObj)
{
DoSomething(pObj, Int2Type<isPolymorphic>());
}
};

int main()
{
	Conteneur2<int , false> cI ;
	cI.DoSomething(new int);
	Conteneur2<A , true> cA ;
	cA.DoSomething(new A);
	return 0;
}
#endif
//pouvez vous expliquer ce fonctionnement ?
