// Purpose.  Class template with layers lab answer

#include <iostream>
#include <string>
#include <sstream>
using namespace std;

template <typename XXX>
struct Node {
   XXX value;
   Node* next;
   Node( XXX val ) { value = val;  next = 0; }
   ~Node()         { cout << value << "-gone  "; }
};

template <typename YYY>
class Queue {
   Node<YYY> *head, *tail;
public:
   Queue() { head = tail = 0; }
   void put( YYY val ) {
      if (tail) {
         tail->next = new Node<YYY>( val );
         tail = tail->next;
      } else
         head = tail = new Node<YYY>( val );
   }
   YYY get() {
      YYY ret = head->value;
      Node<YYY>* going = head;
      head = head->next;
      delete going;
      return ret;
   }
   bool isEmpty() { return head == 0; }
};

void main( void ) {
   Queue<int>    que1;
   Queue<string> que2;
   stringstream  ss;
   for (int i=1; i < 7; i++) {
      que1.put( i );
      ss.str( "" );
      ss << "str" << i;
      que2.put( ss.str() );
   }
   while ( ! que1.isEmpty())
      cout << que1.get() << "  " << que2.get() << '\n';
}

// str1-gone  1-gone  1  str1
// str2-gone  2-gone  2  str2
// str3-gone  3-gone  3  str3
// str4-gone  4-gone  4  str4
// str5-gone  5-gone  5  str5
// str6-gone  6-gone  6  str6
