#include <iostream>
using namespace std;

class Res
{
private:
	char * nom_;
public:
	Res(char* nom= 0)
	{
		if (nom)
		{
			nom_ = new char[strlen(nom)+1];
			strcpy(nom_, nom);
		}
		else 
			nom_=0;
	}
	~Res()
	{
		delete[] nom_;
	}
	
	void print(){cout << "ressource: " ;
	if (nom_)
		cout << nom_ << endl;
	else
		cout << "vide" << endl;
	}
	const char* getNom(){return nom_;}
private:
	//Ctor de copie
	Res(const Res& res);
	//Operateur =
	Res& operator=(const Res& res);
};

class SmartPointer2
{
private:
	Res* ptr;
	int * pCpt;
public:
	SmartPointer2(Res* pRes=0) : ptr(pRes)
	{
		if (pRes)
			pCpt = new int(1);
		else
			pCpt = 0;
	}
	~SmartPointer2() {
		if (ptr) 
		{
			cout << "sp sur " << ptr->getNom()<< " cpt= " << *pCpt << " => " << (*pCpt) - 1 << endl;
			if ((--(*pCpt))==0)
			{
				cout << "destruction de " << ptr->getNom() << endl;
				delete ptr;
			}
		}
		else
			cout << "sp sur <vide> : pas de Compteur" << endl;
	}
	Res* operator->(){return ptr;}
	//Ctor copie
	SmartPointer2(const SmartPointer2& sp)
	{
		pCpt = sp.pCpt;
		ptr = sp.ptr;
		// ! si null
		cout << "sp sur " << ptr->getNom()<< " cpt= " << *pCpt << " => " << (*pCpt) + 1 << endl;
		(*pCpt)++;
	}
	SmartPointer2& operator=(const SmartPointer2& sp)
	{	
		//anti aliasing
		if (&sp == this) 
		{
			cout << "sp sur " << ptr->getNom()<< " cpt= " << *pCpt << " => " << (*pCpt) + 1 << endl;
			(*pCpt)++;
			return *this;
		}
		
		if (pCpt !=0)
		{
			//dcrmentation de l'ancien Compteur
			cout << "sp sur " << ptr->getNom()<< " cpt= " << *pCpt << " => " << (*pCpt) - 1 << endl;
			if ((--(*pCpt))==0)
			{
				cout << "destruction de " << ptr->getNom() << endl;
				delete ptr;
			}
		}
		//incrmentation du nouveau Compteur
		ptr = sp.ptr;
		pCpt = sp.pCpt;
		// ! si null
		cout << "sp sur " << ptr->getNom()<< " cpt= " << *pCpt << " => " << (*pCpt) + 1 << endl;
		(*pCpt)++;
	}
	
private:
};

int main()
{
	
	SmartPointer2 sp1(new Res("aaa"));
	
	sp1->print();
	
	SmartPointer2 sp2 = sp1;
	
	SmartPointer2 sp3(new Res("bb"));
	SmartPointer2 sp4;
	sp3 = sp1;
	sp4 = sp1;
	cout << "======== fin du pgm ==========" << endl;
	return 0;
}
