// Purpose.  Template lab answer

#include <iostream>
#include <string>
#include <sstream>
using namespace std;

template <typename TBD>
class Stack {
   TBD* array;
   int  sp, size;
public:
   Stack( int s = 10 )  { array = new TBD[s];  size = s;  sp = -1; }
   ~Stack()             { delete [] array; }
   void push( TBD val ) { if ( ! isFull()) array[++sp] = val; }
   TBD  pop()           { if (isEmpty()) return 0;  return array[sp--]; }
   bool isFull()        { return sp == size-1; }
   bool isEmpty()       { return sp == -1; }
};

void main( void ) {
   Stack<int>    s1;
   Stack<char>   s2;
   Stack<string> s3;
   stringstream  ss;
   for (int i=0; i < 10; i++) {
      s1.push( i );
      s2.push( 'a' + i );
      ss << "str" << i;
      s3.push( ss.str() );
      ss.str( "" );
   }
   while ( ! s1.isEmpty()) cout << s1.pop() << ' ';
   cout << '\n';
   while ( ! s2.isEmpty()) cout << s2.pop() << ' ';
   cout << '\n';
   while ( ! s3.isEmpty()) cout << s3.pop() << ' ';
   cout << '\n';
}

// 9 8 7 6 5 4 3 2 1 0
// j i h g f e d c b a
// str9 str8 str7 str6 str5 str4 str3 str2 str1 str0