// Purpose.  Functor as predicate lab
//
// Source.  [Josuttis, pp302-304]; C++ Report article, June 2000, pp17-18
//
// Discussion.  A predicate is a function or functor that returns a bool (or
// a value convertible to a bool).  However, not every function that returns
// a bool is a valid predicate for the STL.  There is an additional require-
// ment - it must always return the same result for the same value, it should
// never change its state due to its previous usage.  The function below does
// what it was designed to do - return true when the third element is reached.
// If we convert the function to a functor, then it can be configured to find
// any "nth" element.  But, once you have finished the lab, it will not be
// working the way you expect.
//
// Assignment.
// o Replace the thirdFunc() function with an "Nth" functor class
// o Its constructor should accept the element for which it is expected to
//   report true
// o In main(), replace the reference to thirdFunc with an instantiation of
//   your functor
// o Your output should demonstrate one "small" problem

// On veut crer un prdicat (renvoie un bool...)
// comprendre d'abord ce que fait la fonction thirdFunc
// Le nime lment est dtruit (pas la valeur 'n')
// pour cela, il FAUT une variable qui compte le nombre d'appel
// cette variable doit tre une variable d'instance.
// on notera la prsence de l'appel  erase !
// Crer une classe "Functor", c'est  dire surchargeant l'oprateur "()"
// crer une donne membre n_ : le numro pour lequel la fonction renvoie vrai
// remarque :
// si l'on code simplement :	bool operator() (int n)	{ return n==n_;} 
//		nous n'aurons pas de manifestation curieuse
// convertir la fonction thirdFunc pour observer le comportement du functor
// ... et si l'on rendait le compteur static ? avantage/inconvnient

#include <iostream>
#include <list>
#include <algorithm>
using namespace std;

bool thirdFunc( int ) {
   static int count = 0;
   return ++count == 3;
}

void main( void ) {
   list<int> array;
   for (int i=1; i < 14; i++)
      array.push_back( i );
   list<int>::iterator pos;
//   pos = remove_if( array.begin(), array.end(), thirdFunc );
   pos = remove_if( array.begin(), array.end(), thirdFunc );
   array.erase( pos, array.end() );
   for (pos = array.begin(); pos != array.end(); pos++)
      cout << *pos << ' ';
   cout << '\n';
}

// 1 2 4 5 6 7 8 9 10 11 12 13
