// Purpose.  remove_if => find_if lab
//
// Discussion.  Below are the implementations of remove_if() and find_if().
// Notice that the UnaryPred op is passed by value into both find_if() and
// remove_copy_if().  That is why 2 "third elements" were removed in the
// previous lab.  "This is not a bug.  The standard does not specify how
// often a predicate might be copied internally by an algorithm.  Thus, to
// get the guaranteed behavior of the C++ standard library you should not
// pass a function object for which the behavior depends on how often it is
// copied or called." [Josuttis, p304]  We will get around this unfortunate
// interaction by not "calling" find_if():
//
// Assignment.
// o Copy and paste your Nth functor class
// o Take the implementation of my_find_if() and insert it into my_remove_if()
// o The output should now be correct

//Une bonne solution n'est pas de rendre statique le compteur mais d'viter la copie
// par valeur du functor
// pour cela, on va inliner l'algorithme de find_if
//copie du Functor 
// copie de my_find_if dans my_remove_if
//on remplace : 	beg = my_find_if( beg, end, op );
//par :    while (beg != end  &&  !op(*beg)) ++beg;
//plus de copie non matrise du functor!!!


#include <iostream>
#include <list>
#include <algorithm>
using namespace std;

//copie du Functor
class Nth
{
	int nth;
	int count;
public:
	Nth( int n )                { nth = n;  count = 0; }
   bool operator() ( int val ) { return ++count == nth; }
};

void main( void ) {
   list<int> array;
   for (int i=1; i < 14; i++)
      array.push_back( i );
   list<int>::iterator pos;
   pos = remove_if( array.begin(), array.end(), Nth(3) );
   array.erase( pos, array.end() );
   for (pos = array.begin(); pos != array.end(); pos++)
      cout << *pos << ' ';
   cout << '\n';
}

// 1 2 4 5 7 8 9 10 11 12 13
