//Le vecteur est un sacr copieur
#include <iostream>
#include <vector>
using namespace std;
/*
OK, le vecteur est beaucoup plus pratique que le tableau pour stocker les 'int'
Mais que peut on lui confier  stocker ? avec quels avantages et inconvnients ?

PARTIE I   : le vecteur est vide, on lui ajoute un lment		
PARTIE II  : le vecteur reoit un deuxime lment
PARTIE III : le vecteur reoit un troisime lment
PARTIE IV  : l'insertion autre part qu' la fin du tableau
PARTIE V   : Tentative d'optimisation de l'utilisation du vecteur
PARTIE VI  : Trop de copie ... on utilise des pointeurs... mais attention !
En conclusion : les bonnes pratiques et les interdits

On prendra une classe simple class A dote d'un int pour "voir" comment les choses se passent
*/
class A
{
private :
	int i_;
public:
	A(int i=0) : i_(i){cout << "Ctor : " << i_ << endl;}
//	A(const A& a) : i_(a.i_){cout << "Ctor de copie : " << i_ << endl;} //a dcommenter selon indication
	void print(ostream& out) const{ out << i_;}
//	~A() {cout << "Dtor : " << i_ << endl;}
};
ostream& operator<<(ostream& out, const A& a) { a.print(out); return out;}

int main()
{
//**********************************************************************
//PARTIE I :le vecteur est vide, on lui ajoute un lment		
//**********************************************************************
cout << "vector<A> v;" << endl;
vector<A> v; 		//vecteur vide, destin  stocker des objets A

//ici, le vecteur est vide... la preuve :
cout << "vecteur vide ? " << boolalpha << v.empty() << endl;
A a1(1);		//cration d'un objet de type A
cout << "v.push_back(a1);" << endl;
v.push_back(a1);
//ici, le vecteur n'est plus vide... la preuve :
cout << "vecteur vide ? " << boolalpha << v.empty() << endl;
//on peut accder  sa capacit de stockage : combien d'lments sont stockables sans nouvelle rallocation ?
cout << "capacite du vecteur = " << v.capacity() << ", taille = " << v.size() << endl;
/*mais quel est l'objet qui a t stock par le vector ?
NON, la rponse a1 est FAUSSE ! Je vous avais prvenu (dans le titre de l'article)
 La bonne rponse est UNE COPIE DE a1 !
Comment s'en apercevoir ? en traant l'excution du Ctor de copie => dcommentez le
On peut aussi chercher  crire l'adresse mmoire du premier lment du vecteur : v[0]
*/
cout << "@ de a1: &a1=" << &a1 << " et @ 1er element du vecteur &v[0]="<< &v[0] << endl;
cout << "le vecteur lui-meme est en " << &v << " (pile)" << endl;
/*on remarque ici que les adresses sont dans des plages diffrentes
 a1 est allou sur la pile et l'objet copi dans le vecteur est allou sur le tas... 
donc par de l'allocation dynamique... 
ce qui est ncessaire pour faire voluer dynamiquement sa taille (augmentation ou diminution)
*/
//**********************************************************************
//PARTIE II : le vecteur reoit un deuxime lment
//**********************************************************************
A a2(2);		//cration du deuxime objet de type A
cout << "v.push_back(a2);" << endl;
v.push_back(a2);
/* Cette fois ci, la question est : qu' fait le vecteur ?
On sait qu'il a copi l'objet a2 est qu'il a ajout la copie dans son conteneur
mais allez voir la trace laisse par notre Ctor de copie !
Pour mieux comprendre, allons voir l'adresse des deux lments du vecteur
*/
cout << " &v[0]="<< &v[0] << " et &v[1]="<< &v[1] << endl;
cout << "capacite du vecteur = " << v.capacity() << ", taille = " << v.size() << endl;
 //le conteneur (mmoire alloue) du vecteur se trouvait un peu  l'troit  l'ancienne place,
//il a donc dmnag dans un deux pice... et copi chacun des lments
// Je vous avais prvenu ... blabla

//**********************************************************************
//PARTIE III : le vecteur reoit un troisime lment
//**********************************************************************
A a3(3);
cout << "v.push_back(a3);" << endl;
v.push_back(a3);
/* Cette fois ci, la question est qu' fait le vecteur ?
On sait maintenant qu'il a allou suffisamment de place pour stocker les 3 lments
Mais il a anticip les allocations futures et optimis en allouant 4 objets... la preuve
*/
cout << " &v[0]="<< &v[0] << ", &v[1]="<< &v[1] << " et &v[2]="<< &v[2] << endl;
cout << "capacite du vecteur = " << v.capacity() << ", taille = " << v.size() << endl;
/* Remarquons que ce comportement du vecteur n'est pas spcifi par les standards et que chaque 
implmentation peut se comporter diffremment : le vecteur de l'implmentation VC++ alloue le double de la taille courante
lors de chaque nouveau besoin
Pour vrifier cela, que les lments ne sont pas copis cette fois ci, ajoutons un autre lment
*/
cout << "v.push_back(a4);" << endl;
v.push_back(A(4));
cout << " &v[0]="<< &v[0] << ", &v[1]="<< &v[1] << ", &v[2]="<< &v[2] << " et &v[3]="<< &v[3] << endl;
cout << "capacite du vecteur = " << v.capacity() << ", taille = " << v.size() << endl;
//on retire alors cet lment
cout << "pop_back de : " << v.back()<< " par v.pop_back();" << endl;
v.pop_back();
//remarque 1 : l'appel  pop_back() appelle le destructeur de l'objet chass
//remarque 2 : le pop_back ne renvoie rien, il convient d'avoir rcupr l'objet par back() si besoin est
cout << "capacite du vecteur = " << v.capacity() << ", taille = " << v.size() << endl;
/*
Pourquoi ces rallocations ? 
Car le vecteur est implment par un tableau en memoire dynamique ... et tous les lments d'un tableau sont contigus 
C'est d'ailleurs ce qui rend le tableau si efficace lors de l'accs alatoire par l'oprateur []
L'lment 2 est alors rcupr directement par son adresse : adresse_dbut_tableau+2*sizeof(lment)

**********************************************************************
PARTIE IV : l'insertion autre part qu' la fin du tableau
**********************************************************************
Il existe la possibilit d'insrer des lments  la position de notre choix dans le tableau
La mthode 'insert' permet cela,  condition de lui fournir un itrateur initialis sur l'lment
devant lequel on veut insrer notre nouvel lment.
Par exemple, pour initialiser un itrateur au dbut du vecteur :
*/
vector<A>::iterator it = v.begin();
// Pour insrer un objet a4 :
A a4(4);
cout << "v.insert(v.begin(), a4);" << endl;
v.insert(v.begin(), a4);//ou  des emplacements diffrents : v.insert(v.begin()+1, a4); 
//v.insert(it, a4);
cout << " &v[0]="<< &v[0] << ", &v[1]="<< &v[1] << ", &v[2]="<< &v[2] << ", &v[3]="<< &v[3] << " et &v[4]="<< &v[4] << endl;
/* Que fait le vecteur  votre avis ?
Comment ? il copie tout le monde ? tous les lments suivant le point d'insertion ?
et ceci, mme s'il a suffisamment de place dans sa capacit ?
PAS DU TOUT ! sur ce coup l, il optimise les appels au ctor de copie dans les dplacements mmoire
C'est pour montrer ceci que nous avons retir l'ancien 4me lment dans la partie prcdente. 
Mais au fait, comment les lments sont ils dplacs ?
Comme nos Ctors de copies ne sont pas appels, la copie est faite par bit-copy
*/
//ici des exemples de parcours du vecteur fonctionnellement identiques
for (it=v.begin(); it!=v.end(); it++)//boucle avec itrateur
	cout << *it << " ";		//impression de llment via l'itrateur (drfrenc)
cout << endl;
for (int i =0; i<v.size(); i++)//boucle simple
	cout << v[i] << " ";	//impression de llment via l'oprateur []
cout << endl;
//ici une faible utilisation du vecteur, le parcours direct par un pointeur utilisateur
A * ptr = &v[0];
for (int ii=0; ii<4; ii++)
	cout << *ptr++ << " " ;
cout << endl; 

/*********************************************************************
PARTIE V : Tentative d'optimisation de l'utilisation du vecteur
**********************************************************************
Que de copies d'objet lorsque les insertions sont faites une par une !
Dans le cas de figure ou nous savons  peu prs combien d'objets seront mis dans le vecteur,
l'ide est de TAILLER notre vecteur ds le dbut.
Pour faire cela, tournons nous vers les Constructeurs du vecteur, nous en voyons un qui SEMBLE
rpondre  notre souhait
explicit vector(size_type n, const T& v = T(), const A& al = A());
Utilisons le pour vrifier son fonctionnement 
*/
cout << "vector<A> v2(5);" << endl;
vector<A> v2(5);
/*Qu'a t il fait ?
BRAVO : il a copi ! il a d'abord utilis le Ctor par dfaut de A pour crer un objet temporaire
il a ensuite utilis cet objet temporaire comme source d'information pour la cration par le Ctor de copie 
des autres lments (les vrais) v2[0], .... v2[4] et il a ensuite dtruit l'objet temporaire.
On voit aussi que l'on peut choisir l'objet source de copie en codant ainsi :
*/
cout << "vector<A> v3(5, A(10));\n";
vector<A> v3(5, A(10));
/*
Quand un vecteur est trop petit, peux t on suggrer nous mme l'aggrandissement ?
OUI en utilisant la mthode resize()
*/
cout << "avant resize : capacity=" << v3.capacity() << " et size=" << v3.size() << endl;
cout << "v3.resize(20);\n";
v3.resize(20);
cout << "apres resize : capacity=" << v3.capacity() << " et size=" << v3.size() << endl;
/*
On a pas mal de copies, mais par rapport  la construction d'un vecteur vide suivi de push_back
on gagne les rallocations mmoire et copies intermdiaires successives
Mais n'y a t il pas un moyen de tailler le vecteur SANS CREER TOUS CES OBJETS ?
La rponse est dans la mthode reserve()
*/
vector<A> v4;
cout << "\nv4.reserve(20); \n";
v4.reserve(20);
cout << "apres reserve : capacity=" << v4.capacity() << " et size=" << v4.size() << endl;
//reserve est diffrent de resize dans la mesure ou il ne s'occupe que de la mmoire alloue
//et PAS des objets du vecteur : pas de cration et donc pas de copie

/*************************************************************************
PARTIE VI : Trop de copie ... on utilise des pointeurs... mais attention !
**************************************************************************
Que de copies d'objet ! l'ide suivante est de ne confier au conteneur que des pointeurs
sur mes objets
On va donc crer un objet dynamiquement et l'ajouter au vecteur
*/ 

{
A* pa=new A(1);
vector<A*> v5;
v5.push_back((A*)&v5);
v5.resize(2);//cette fois ci, le resize ne fait pas de copie d'objet
cout << "cap=" <<v5.capacity() << " et size=" << v5.size() << endl;
//ici, une boucle jusqu'a size-1 provoquerait un TRAP
for (int i =0; i<v5.size(); i++)//boucle simple
//	cout << *v5[i] << " ";	//A dcommenter pour voir le trap
cout << endl;
//ici, lorsque le vecteur va tre dtruit, ne pas oublier de librer l'objet par
delete pa; // car le destructeur de vector ne fera rien pour nos pointeurs
}
return 0;
}
/*
En conclusion :
La bonne pratique est d'anticiper la taille finale de l'objet vecteur ds sa construction
ou au moins par une opration de reserve faite avant la premire insertion.
Ceci n'est pas toujours possible ... videmment

Les interdits :
- si vous avez un objet lent  copier ou un objet non copiable (Ctor de copie priv)
il est impossible d'utiliser le vecteur
- De mme, si votre objet ne possde pas de Ctor par dfaut, l'utilisation du vecteur est handicappe
car les resize y font appel
- Pour viter toutes les copies lourdes, on pourrait envisager de confier des pointeurs  notre vecteur
Mais alors il faut grer nous mme la synchronisation du conteneur, des pointeurs et des objets
En particulier, la cration par new d'un objet et l'ajout du pointeur dans le vecteur ncessitera
l'appel  delete lors de la destruction du vecteur... car le vecteur appellera seulement le destructeur
 de ce que nous lui avons confi... un pointeur. Le type pointeur n'tant pas une classe, aucun destructeur
 n'est appel automatiquement.
*/