//#define IMBRIQUE

#include <iostream>
#include <vector>
using namespace std;

template <class T>
class Iterator
{
public:
	virtual bool HasNext() const =0;
	virtual T Next() const =0;
};


#ifndef IMBRIQUE
// class externe friend
template <class T>
class IteratorImpl : public Iterator<T>
{
	mutable int index;
	vector<T>& vec;
public:
	IteratorImpl(vector<T>& v) : vec(v), index(0) {}
	bool HasNext() const	{return (index < vec.size());}
	T Next() const		{return vec[index++];}
};
#endif

template <class T>
class Conteneur
{
#ifdef IMBRIQUE
//classe imbrique
	class IteratorImpl : public Iterator<T>
{
	mutable int index;
	vector<T> vec;
public:
	IteratorImpl(vector<T>& v) : vec(v), index(0) {}
	bool HasNext() const {return (index < vec.size());}
	T Next() const	{return vec[index++];}
};
#else
	friend IteratorImpl<T>;
#endif
	vector<T> vec;
public:
	Conteneur(int i){vec.reserve(i);}
	void Add(int n) { vec.push_back(n);}
#ifdef IMBRIQUE
	Iterator<T>* iterator(){return new IteratorImpl(vec);}
#else
	Iterator<T>* iterator(){return new IteratorImpl<T>(vec);}
#endif
};

int main()
{
	const int N = 10;
	Conteneur<int> c(N);
	for (int i=0; i<N-3; i++)
		c.Add(i);
	Iterator<int>* it = c.iterator();
	while (it->HasNext())
		cout << it->Next() << " " ;
	return 0;
}
