// Purpose.  priority_queue lab answer

#include <iostream>
#include <list>
using namespace std;

class Command {
public:
   Command() { id = next++;   priority = id % 2 ? 8 : 5; }
   friend bool operator< ( const Command& left, const Command& right ) {
      return left.priority < right.priority; }
   friend ostream& operator<< ( ostream& os, const Command& cmd ) {
      return os << cmd.id << "-" << cmd.priority; }
private:
   int id, priority;
   static int next;
};
int Command::next = 1;


template <class XXX>
class PriorityQueue {
public:
   void push( XXX c ) {
      list<XXX>::iterator it;
      for (it = que.begin(); it != que.end(); it++)
         if ( ! (*it < c)) break;
      que.insert( it, c );
   }
   XXX pop() {
      XXX cmd = que.back();
      que.pop_back();
      return cmd;
   }
   bool empty() { return que.size() == 0; }
private:
   list<XXX> que;
};


void main( void ) {
   PriorityQueue<Command>     pq;
   // priority_queue<Command> pq;
   for (int i=0; i < 10; i++)
      pq.push( Command() );
   while ( ! pq.empty()) {
      cout << pq.pop() << " ";
      // cout << pq.top() << " ";
      // pq.pop();
   }
   cout << endl;
}

///// PriorityQueue
// 1-8 3-8 5-8 7-8 9-8 2-5 4-5 6-5 8-5 10-5

///// standard library priority_queue
// 1-8 3-8 7-8 5-8 9-8 10-5 6-5 4-5 2-5 8-5
