// Purpose.  auto_ptr ownership lab
//
// Assignment.
// o Replace all references to Base* with auto_ptr<Base> 
// o Make any other necessary changes (e.g. does ownObject() need to delete?)
// o Is there anything you need to do with pointers that this lab does not
//   address?

#include <iostream>
using namespace std;

class Base { public:
   virtual ~Base() { }
   virtual void setValue( int ) = 0;
   virtual int  getValue() const = 0;
};

class A : public Base {
   int value;
public:
   A( int val )    { value = val;  cout << "Actor-" << value << '\n'; }
   A( const A& o ) { cout << "A copy ctor - " << o.value << '\n'; }
   ~A()            { cout << "dtorA-" << value << '\n'; }
   A& operator=( const A& rhs ) { cout << "A op= " << rhs.value << '\n'; }
   friend ostream& operator<< ( ostream& os, const A& obj ) {
      return os << "A-" << obj.value;
   }
   /*virtual*/ void setValue( int val ) { value = val; }
   /*virtual*/ int  getValue() const { return value; }
};

Base* makeObject( int val ) { return new A( val ); }

void useObject( Base* const ptr ) { ptr->setValue( ptr->getValue() + 1 ); }

void ownObject( Base* ptr ) {
   ptr->setValue( ptr->getValue() + 1 );
   cout << "ownObject: value is " << ptr->getValue() << '\n';
   delete ptr;
}

void main( void ) {
   Base* ptr = makeObject( 0 );
   for (int i=0; i < 4; i++) {
      useObject( ptr );
      cout << "main: value is " << ptr->getValue() << '\n';
   }
   ownObject( ptr );
   cout << "main: done\n";
}

// Actor-0
// main: value is 1
// main: value is 2
// main: value is 3
// main: value is 4
// ownObject: value is 5
// dtorA-5
// main: done
