// Purpose.  auto_ptr with exception lab answer

#include <string>
#include <memory>
using namespace std;

class Outer {
   class Inner {
      char value;
   public:
      Inner( char val ) {
         if (val == 'f') throw "out of luck";
         value = val;
         cout << "ctor-" << value << "  ";
      }
      ~Inner() { cout << value << "-dtor" << "  "; }
      void report() { cout << value << ' '; }
   };

   int   value;
   auto_ptr<Inner> one; 
   auto_ptr<Inner> two;
public:
   Outer( int val ) : one( new Inner( (val-1) * 2 + 'a' ) ),
                      two( new Inner( (val-1) * 2 + 'b' ) ) {
      value = val;
      cout << "ctor-" << value << '\n'; 
   }
   ~Outer() { cout << value << "-dtor" << "  "; }
   void report() {
      cout << value << " -- ";
      one->report();
      two->report();
      cout << '\n';
   }
};

void main( void ) {
   try {
      for (int i=1; i < 4; i++) {
         cout << '\n';
         Outer object( i );
         object.report();
      }
   } catch (char* ex) {
      cout << "\nmain - EXCEPTION - " << ex << '\n';
}  }

// ctor-a  ctor-b  ctor-1
// 1 -- a b
// 1-dtor  b-dtor  a-dtor
// ctor-c  ctor-d  ctor-2
// 2 -- c d
// 2-dtor  d-dtor  c-dtor
// ctor-e  e-dtor
// main - EXCEPTION - out of luck
