/*-----------------------------------------------------------------------------------------
 Exemple : Callback  une fonction membre en utilisant un argument additionnel

Tche: Soit une fonction globale 'Enregistrer'
Elle doit effectuer une action qui implique un callback 
vers une des fonctions membres de la classe Client 'Affiche' ou 'Dessine'.
	void Affiche(const char* text)
	{ cout << "Affiche: " << text << endl; };
	void Dessine(const char* text)
	{ cout << "Dessine: "<< text << endl; };

en utilisant les pointeurs de fonction, 
faire fonctionner le code ci dessous (extrait du "main")
	Enregistrer(client, <ptrsurAffiche ou Dessine>)

Pour cela, penser  utiliser des fonctions statiques wrappeurs
  'Wrappeur_Affiche' et 'Wrappeur_Dessine'

en effet, un pointeur de fonction global ne peut directement rfrencer une 
mthode d'instance
*/

#include <iostream.h> 

class Client
{
public:
void Affiche(const char* text) { cout << "Affiche: " << text << endl; };
void Dessine(const char* text) { cout << "Dessine: "<< text << endl; };
static void Wrappeur_Affiche(void* pt2Object, char* text);
static void Wrappeur_Dessine(void* pt2Object, char* text);
};

// fonction statique 'callback' vers la fonction membre Affiche()
void Client::Wrappeur_Affiche(void* pt2Object, char* string)
{
// cast explicite en pointeur de Client
Client* pSelf = (Client*) pt2Object;
// appel du membre
pSelf->Affiche(string);
}
void Client::Wrappeur_Dessine(void* pt2Object, char* string)
{
((Client*) pt2Object)->Dessine(string);
}


/* //erreur
typedef void (Client::*PF)(char* text);
void Enregistrer(void* pt2Object, PF pt2Function)
{
Client* pSelf = (Client*) pt2Object;
pSelf->*pt2Function("Je rappelle avec un argument <string>");
}
*/
void Enregistrer(void* pt2Object, void (*pt2Function)(void* pt2Object, char* text))
{
pt2Function(pt2Object, "Je rappelle avec un <string>");
}


void main () //Callback avec Argument
{
Client client1;
//erreur 
//Enregistrer((void*) &client1, Client::Affiche);
Enregistrer((void*) &client1, Client::Wrappeur_Affiche);
Enregistrer((void*) &client1, Client::Wrappeur_Dessine);
}
