/*-----------------------------------------------------------------------------------------
Exemple : Callback  une fonction membre en utilisant un argument additionnel

I) fonctions globales 
======================
  Soit une fonction globale 'Enregistrer' et une fonction 'Message'
  Enregister : 
  doit enregistrer les abonns dans une collection
  Message :
  doit renvoyer le message aux autres abonns
  
Crer une classe ClientChat possdant les facults d'envoyer et de recevoir un ou plusieurs messages
Il ne connaitra les fonctions globale d'enregitrement/envoi qu' l'excution
  
Tester avec le code suivant :
void main () //Callback avec Argument
{
	ClientChat client1("client1");
	ClientChat client2;
	ClientChat client3("client3");

	Enregistrer(client1);
	Enregistrer(client2);
	Enregistrer(client3);
	cout << "<<client1>> EnvoieMessage \"salut a tous \" "<< endl;
	client1.EnvoieMessage("salut a tous ", Message);
}

et on attend :
<<client1>> EnvoieMessage "salut a tous "
<<anonyme>> recoit: salut a tous : de <<client1>>
<<client3>> recoit: salut a tous : de <<client1>>


II) classe ServeurChat
=======================
Crer la classe ServeurChat et lui donner
 une mthode statique 'Enregistrer' et une mthode 'Message'
- Enregister : 
  doit enregistrer les abonns dans une collection
- Message :
  doit renvoyer le message aux autres abonns
	Dvelopper la classe ServeurChat et la classe ClientChat

  tester avec le code suivant:
	ServeurChat::Enregistrer(client1);
	ServeurChat::Enregistrer(client2);
	ServeurChat::Enregistrer(client3);
	cout << "<<client1>> EnvoieMessage \"salut a tous \" "<< endl;
	client1.EnvoieMessage("salut de client 1", &ServeurChat::Message);

*/

//
#define CLASSE
#include <iostream> 
#include <string> 
#include <vector> 
using namespace std;


class ClientChat
{
typedef void PF(string, ClientChat*);
private:
	string nom_;
public:
	ClientChat(string nom="anonyme"): nom_(nom){};
	string GetNom(){return nom_;}
	void RecoitMessage(string text)
	{
		cout << "<<"<< nom_ << ">> recoit: " << text << endl; 
	}
	void EnvoieMessage(string text, PF pf)
	{
		pf(text, this); 
	}
};

#ifndef CLASSE
vector<ClientChat*> abonnes;
void Enregistrer(ClientChat& client)
{
	abonnes.push_back(&client);
}
void Message(string msg, ClientChat* envoyeur)
{
	msg += ": de <<" + envoyeur->GetNom() + ">>";
	for (int i=0; i<abonnes.size(); i++)
		{
			if (envoyeur==abonnes[i]) continue;
			abonnes[i]->RecoitMessage(msg);
		}
}
#else
class ServeurChat
{
private:
	static vector<ClientChat*> abonnes;
public:
	static void Enregistrer(ClientChat& client)
	{
		abonnes.push_back(&client);
	}
	static void Message(string msg, ClientChat* envoyeur)
	{
		for (int i=0; i<abonnes.size(); i++)
		{
			if (envoyeur==abonnes[i]) continue;
			abonnes[i]->RecoitMessage(msg);
		}
	}
};
vector<ClientChat*> ServeurChat::abonnes;
#endif


void main () //Callback avec Argument
{
	ClientChat client1("client1");
	ClientChat client2;
	ClientChat client3("client3");

#ifndef CLASSE
	cout << "fonction globale"<<endl;
	Enregistrer(client1);
	Enregistrer(client2);
	Enregistrer(client3);
	cout << "<<client1>> EnvoieMessage \"salut a tous \" "<< endl;
	client1.EnvoieMessage("salut a tous ", Message);
#else
	cout << "methode de classe"<<endl;
	ServeurChat::Enregistrer(client1);
	ServeurChat::Enregistrer(client2);
	ServeurChat::Enregistrer(client3);
	cout << "<<client1>> EnvoieMessage \"salut a tous \" "<< endl;
	client1.EnvoieMessage("salut de client 1", &ServeurChat::Message);
#endif
}
