// Purpose.  Generic programming lab (sequence)
//
// Assignment.
// o Take your sort1Lab answer and change the interface of sort() to accept a
//   sequence (i.e. "begin" and "end" arguments)
// o The implementation of sort() can largely stay the same if you understand
//   that the "begin" argument is really the base of a virtual array, and the
//   size of that virtual array is "end - begin"
// o Instead of the 3-line swap block, call the swap() function provided by the
//   standard library

//copie de la fonction sort
// son prototype doit voluer (gnralisation) pour accepter des itrateurs templates
// sort (begin, end)
// pour conserver l'algorithme, on va calculer la taille (end-begin)
//		 l'aide de l'algorithme "distance", ce qui remplacera l'argument "int n"
// Conseil : utiliser distance pour obtenir la distance de parcours entre deux iterators
// et utiliser swap

#include <iostream>
#include <vector>
#include <ctime>
using namespace std;

//copie de la fonction sort
template <class T>
//void sort( T v[] , int n ) {
void sort( T v /*begin*/, T end ) {
	int n = distance(v, end);
	for (int g = n/2; g > 0; g /= 2)
		for (int i = g; i < n; i++)
			for (int j = i-g; j >= 0; j -= g)
				if (v[j] > v[j+g]) {
					swap(v[j], v[j+g]);
					//on ne peut garder l'ancien algo... remplacement par swap
					//T temp = &v[j];//avant T temp = v[j];
					//v[j] = v[j+g];
					//v[j+g] = *temp;//avant v[j+g] = temp
				}
}

void main( void ) {
   srand( time(0) );
   const int NUM = 15;
   int array[NUM], array2[NUM];
   for (int i=0; i < NUM; i++) array[i] = rand() % 20 + 1;
   memcpy( array2, array, sizeof(int) * NUM );
   for (i=0; i < NUM; i++) cout << array[i] << ' ';   cout << '\n';
   sort( array, array+NUM );
   for (i=0; i < NUM; i++) cout << array[i] << ' ';   cout << '\n';

   vector<int>  vec( array2, array2+NUM );
   for (i=0; i < NUM; i++) cout << vec[i] << ' ';     cout << '\n';
   sort( vec.begin(), vec.end() );
   for (i=0; i < NUM; i++) cout << vec[i] << ' ';     cout << '\n';
}

// 12 17 6 13 16 20 9 1 2 6 6 3 12 4 9
// 1 2 3 4 6 6 6 9 9 12 12 13 16 17 20
// 12 17 6 13 16 20 9 1 2 6 6 3 12 4 9
// 1 2 3 4 6 6 6 9 9 12 12 13 16 17 20
