// Purpose.  Generic programming lab answer (parameterize a strategy)

#include <iostream>
#include <vector>
#include <functional>
#include <ctime>
using namespace std;

// template <typename TBD, typename COMP = greater<int> >
// WARNING: default template args are only allowed on a class template; ignored
//          -------

template <typename TBD, typename COMP>
void sort( TBD v, TBD end, COMP func ) {
   int n = distance( v, end );
   for (int g = n/2; g > 0; g /= 2)
      for (int i = g; i < n; i++)
         for (int j = i-g; j >= 0; j -= g)
            if (func( v[j], v[j+g] ))
               swap( v[j], v[j+g] );
}

void main( void ) {
   srand( time(0) );
   const int NUM = 15;
   vector<int>  vec( NUM );
   for (int i=0; i < NUM; i++) vec[i] = rand() % 20 + 1;
   for (i=0; i < NUM; i++) cout << vec[i] << ' ';   cout << '\n';
   sort( vec.begin(), vec.end(), greater<int>() );
   for (i=0; i < NUM; i++) cout << vec[i] << ' ';   cout << '\n';
   sort( vec.begin(), vec.end(), less<int>() );
   for (i=0; i < NUM; i++) cout << vec[i] << ' ';   cout << '\n';
}

// 18 1 20 4 20 3 8 20 9 12 13 14 6 15 20
// 1 3 4 6 8 9 12 13 14 15 18 20 20 20 20
// 20 20 20 20 18 15 14 13 12 9 8 6 4 3 1
