// Purpose.  Generic programming lab answer (objectify the strategy)

#pragma warning( disable : 4786 )
#include <iostream>
#include <vector>
#include <string>
#include <functional>
#include <ctime>
using namespace std;

template <typename TYP>
bool my_greater( TYP one, TYP two ) { return one > two; }

template <>
bool my_greater( string one, string two ) {
   for (int i= 0; i < one.size() && i < two.size(); i++)
      if (tolower(one[i]) == tolower(two[i]))
         ;
      else return tolower(one[i]) > tolower(two[i]);
   return one.size() > two.size();
}

template <typename TYP>
class my_greater_functor {
public:
   bool operator()( TYP one, TYP two ) { return one > two; }
};

class my_greater_functor<string> {
public:
   bool operator()( string one, string two ) {
      for (int i= 0; i < one.size() && i < two.size(); i++)
         if (tolower(one[i]) == tolower(two[i]))
            ;
         else return tolower(one[i]) > tolower(two[i]);
      return one.size() > two.size();
}  };

template <typename TBD, typename COMP>
void sort( TBD v, TBD end, COMP func ) {
   int n = distance( v, end );
   for (int g = n/2; g > 0; g /= 2)
      for (int i = g; i < n; i++)
         for (int j = i-g; j >= 0; j -= g)
            if (func( v[j], v[j+g] ))
               swap( v[j], v[j+g] );
}

void main( void ) {
   srand( time(0) );
   vector<string> vec( 15 );
   char ch;
   for (int i=0; i < vec.size(); i++)
      for (int j=0; j < 4; j++) {
         ch = rand() % 26 + 65 + (rand()%2 ? 32 : 0);
         vec[i] += ch;
      }
   for (i=0; i < vec.size(); i++) cout << vec[i] << ' ';   cout << '\n';
   sort( vec.begin(), vec.end(), greater<string>() );
   for (i=0; i < vec.size(); i++) cout << vec[i] << ' ';   cout << '\n';
   sort( vec.begin(), vec.end(), my_greater<string> );
   for (i=0; i < vec.size(); i++) cout << vec[i] << ' ';   cout << '\n';
   sort( vec.begin(), vec.end(), less<string>() );
   for (i=0; i < vec.size(); i++) cout << vec[i] << ' ';   cout << '\n';
   sort( vec.begin(), vec.end(), my_greater_functor<string>() );
   for (i=0; i < vec.size(); i++) cout << vec[i] << ' ';   cout << '\n';
}

// UOBS oZfo FZLW AtJw wbwj UcsF DmzU ZrhC TLqn vHwO XamJ fQDA aiAq SUhl puoz
// AtJw DmzU FZLW SUhl TLqn UOBS UcsF XamJ ZrhC aiAq fQDA oZfo puoz vHwO wbwj
// aiAq AtJw DmzU fQDA FZLW oZfo puoz SUhl TLqn UcsF UOBS vHwO wbwj XamJ ZrhC
// wbwj vHwO puoz oZfo fQDA aiAq ZrhC XamJ UcsF UOBS TLqn SUhl FZLW DmzU AtJw
// aiAq AtJw DmzU fQDA FZLW oZfo puoz SUhl TLqn UcsF UOBS vHwO wbwj XamJ ZrhC
