// Purpose.  Exception lab answer

#include <iostream>
#include <string>
using namespace std;

template <typename TBD>
class Stack {
   TBD* array;
   int  sp, size;
public:
   class Empty { };
   class Full  { };
   Stack( int s = 10 )  { array = new TBD[s];  size = s;  sp = -1; }
   ~Stack()             { delete [] array; }
   bool isFull()        { return sp == size-1; }
   bool isEmpty()       { return sp == -1; }
   void push( TBD val ) throw( Full ) {
      if (isFull()) throw Full();
      array[++sp] = val;
   }
   TBD pop() throw( Empty ) {
      if (isEmpty()) throw Empty();
      return array[sp--];
}  };

void main( int argc, char* argv[] ) {
   Stack<int> s;
   try {
      for (int i=0; i < 10; i++)
         s.push( i );
      if (argc == 2) s.push( i );
      while ( ! s.isEmpty())
         cout << s.pop() << ' ';
      cout << '\n';
      if (argc == 3) s.pop();
   } catch (Stack<int>::Empty) {
      cout << "tried to pop() an empty stack\n";
   } catch (Stack<int>::Full) {
      cout << "tried to push() a full stack\n";
   }
   cout << "normal flow of control\n";
}

// D:> advcpp
// 9 8 7 6 5 4 3 2 1 0
// normal flow of control
//
// D:> advcpp 2
// tried to push() a full stack
// normal flow of control
//
// D:> advcpp 2 3
// 9 8 7 6 5 4 3 2 1 0
// tried to pop() an empty stack
// normal flow of control
