
//#define DEBUG_SF_MEM_MGR
//#define DEBUG_MALLOCV2

#include "mallocV2.h"
#include "memmgr.h"

/*
wrapper functions
*/

SequentialFitMemoryManager *mmptr;

void initMemMgr(unsigned long totalbytes)
{ 
	mmptr = new SequentialFitMemoryManager(totalbytes); 
}

void closeMemMgr()
{ 
	delete(mmptr); 
}

void *newMalloc(unsigned long size)
{ 
	void *ptr = (*mmptr).allocate(size);

#ifdef DEBUG_MALLOCV2
	(*mmptr).printState();
#endif

	return(ptr); 
}

void newFree(void *ptr)
{
	(*mmptr).release(ptr);

#ifdef DEBUG_MALLOCV2
	(*mmptr).printState();
#endif

	return;
}