#include "common.h"

/*holds setup data to pass to constructor*/

struct TestData
{
	double *dptr;					// probability array
	unsigned long *lptr;			// allocation sizes
	unsigned long samplesize;		// # malloc() calls
	unsigned long length;			// size of arrays
};

class PerformanceTest
{
	public:
	PerformanceTest(struct TestData *tdptr);
	unsigned long runTest();

	private:
	unsigned long nAllocations;		// # of malloc() calls to make
	unsigned long arraySize;		// size of P(x) and x arrays
	double *p;						// P(x) = probability for X=x
	unsigned long *x;				// X    = # bytes allocated

	double getU();
	unsigned long getRandomVariate();
	void getAllocArray(unsigned long *lptr);	
};

void PerformanceTestDriver();
