#include "mallocV3.h"
#include "perform.h"

void debugTest()
{
	void *ptr[6];
	unsigned long allocs[6]={8,12,33,1,122,50};
	int i;

	initMemMgr(1024*1024);

	for(i=0;i<6;i++)
	{
		ptr[i] = newMalloc(allocs[i]);
		if(ptr[i]==NULL){ printf("ptr[%lu]==NULL!\n",i); }
	}

	printf("\n\nFREE MEMORY-------------------------------------\n\n");

	newFree(ptr[0]);	//8
	newFree(ptr[3]);	//1
	newFree(ptr[4]);	//122
	newFree(ptr[2]);	//33
	newFree(ptr[1]);	//12
	newFree(ptr[5]);	//50

	closeMemMgr();
	return;

}/*end debugTest---------------------------------------------------*/

void main()
{
	//for the debug test, should activate debug macros in mallocVx.cpp 
	//debugTest();

	//for the performance test, should comment out debug macros
	PerformanceTestDriver();
	return;

}/*end main--------------------------------------------------------*/