#include "mallocV3.h"

/*
wrapper functions
*/

SegregatedMemoryManager *mmptr;

void initMemMgr(unsigned long totalbytes)
{ 
	mmptr = new SegregatedMemoryManager(totalbytes); 
}

void closeMemMgr()
{ 
	delete(mmptr); 
}

void *newMalloc(unsigned long size)
{ 
	void *ptr = (*mmptr).allocate(size);

#ifdef DEBUG_MALLOCV3
	(*mmptr).printState();
#endif

	return(ptr); 
}

void newFree(void *ptr)
{
	(*mmptr).release(ptr);

#ifdef DEBUG_MALLOCV3
	(*mmptr).printState();
#endif

	return;
}