#ifndef __MEMMGR_H__
#define __MEMMGR_H__
#include "common.h"

#ifdef  DEBUG_SL_MEM_MGR
#define MSG0(arg);			printf(arg);
#define MSG1(arg1,arg2);	printf(arg1,arg2);
#else
#define MSG0(arg);		
#define MSG1(arg1,arg2);	
#endif

#define U1 unsigned char
#define U4 unsigned long

/*
	list element format  
	                      |0|  |1 .. n|
						[STATE][payload]
	                       U1      ?  

	byte allocated/freed is address of first byte of payload
	header = 1 bytes
*/

#define STATE(i)	(*((U1*)(&ram[i-1])))  /*FREE,OCCUPIED*/

#define FREE				0
#define OCCUPIED			1

#define START16		1		/*index of first 16-byte payload*/
#define START32		18		/*index of first 16-byte payload*/
#define START64		51		/*index of first 16-byte payload*/
#define START128	116		/*index of first 16-byte payload*/
#define START256	245		/*index of first 16-byte payload*/
#define START512	502		/*index of first 16-byte payload*/
#define START1024	1015	/*index of first 16-byte payload*/
#define START4096	2040	/*index of first 16-byte payload*/

#define SZ_ROW		6136	/*size of a row of entries in table*/		

class SegregatedMemoryManager
{
	private:
	HANDLE handle;
	U1  *ram;		/*memory storage*/
	U4  size;		/*# bytes*/
	U4  nrows;		/*# of 6136 byte rows*/

	void initColumn(U4 index);
	U4 searchColumn(U4 index);
	void printColumn(U4 index);

	public:

	SegregatedMemoryManager(U4 nbytes);
	~SegregatedMemoryManager();
	
	void*allocate(U4 nbytes);
	void release(void* addr);
	void printState();
};

#endif //__MEMMGR_H__